// init: The initial user-level program

#include "kernel/include/types.h"
#include "kernel/include/stat.h"
#include "kernel/include/file.h"
#include "kernel/include/fcntl.h"
#include "xv6-user/user.h"
#include "kernel/include/sysnum.h"

#define __asm_syscall(...)           \
    __asm__ __volatile__("ecall\n\t"   \
                        :"=r"(a0)    \
                        :__VA_ARGS__  \
                        :"memory");  \
    return a0;

static inline long __syscall0(long n){
  register long a7 __asm("a7")=n;
  register long a0 __asm__("a0");
  __asm_syscall("r"(a7))
}

char *argv[] = { 0 };

char *files[]={"brk","chdir","clone","close","dup","dup2","execve","exit","fork","fstat","getcwd",
  "getdents","getpid","getppid","gettimeofday","mkdir_","mmap","mount","munmap","open","openat",
  "pipe","read","sleep","times","umount","uname","unlink","wait","waitpid","write","yield",
  0};

//char *files[]={"wait",0};
int
main(void)
{
  int pid, wpid;

  // if(open("console", O_RDWR) < 0){
  //   mknod("console", CONSOLE, 0);
  //   open("console", O_RDWR);
  // }
  dev(O_RDWR, CONSOLE, 0);
  dup(0);  // stdout
  dup(0);  // stderr

  for(int i=0;files[i];i++){
    printf("init: starting sh\n");
    pid = fork();
    if(pid < 0){
      printf("init: fork failed\n");
      exit(1);
    }
    if(pid == 0){
      exec(files[i], argv);
      printf("init: exec sh failed\n");
      exit(1);
    }
    for(;;){
      // 父进程等待子进程结束
      wpid = wait((int *) 0);
      if(wpid==pid){
        break;
      }
      else if (wpid < 0) {
        printf("init: wait returned an error\n");
        exit(1);
      }
    }
  }
  printf("init: all test cases completed, shutting down...\n");
  __syscall0(SYS_shutdown);
  return 0;
}
